(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core'], factory) :
	(factory((global.ngx = global.ngx || {}, global.ngx.dragdrop = global.ngx.dragdrop || {}),global.ng.core));
}(this, (function (exports,_angular_core) { 'use strict';

var __decorate$2 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") { r = Reflect.decorate(decorators, target, key, desc); }
    else { for (var i = decorators.length - 1; i >= 0; i--) { if (d = decorators[i]) { r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r; } } }
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$1 = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") { return Reflect.metadata(k, v); }
};
/* Copyright VMware, Inc. All rights reserved. VMware Confidential */
var NgxDragDropService = (function () {
    function NgxDragDropService() {
        this.defaultInstanceName = 'ngx-dragdrop';
        this.setDefaultInstance();
    }
    Object.defineProperty(NgxDragDropService.prototype, "instanceName", {
        get: function () {
            return this.name;
        },
        set: function (name) {
            this.name = name;
        },
        enumerable: true,
        configurable: true
    });
    NgxDragDropService.prototype.setDefaultInstance = function () {
        this.name = this.defaultInstanceName;
    };
    NgxDragDropService.prototype.isDefaultInstance = function () {
        return this.name === this.defaultInstanceName;
    };
    return NgxDragDropService;
}());
NgxDragDropService = __decorate$2([
    _angular_core.Injectable(),
    __metadata$1("design:paramtypes", [])
], NgxDragDropService);

var __decorate$1 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") { r = Reflect.decorate(decorators, target, key, desc); }
    else { for (var i = decorators.length - 1; i >= 0; i--) { if (d = decorators[i]) { r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r; } } }
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") { return Reflect.metadata(k, v); }
};
/* Copyright VMware, Inc. All rights reserved. VMware Confidential */
var NgxDraggableDirective = (function () {
    function NgxDraggableDirective(el, dragDropService) {
        this.el = el;
        this.dragDropService = dragDropService;
        this._isDraggable = false;
    }
    Object.defineProperty(NgxDraggableDirective.prototype, "isDraggable", {
        get: function () {
            return this._isDraggable;
        },
        set: function (dragEnabled) {
            this.el.nativeElement.setAttribute('draggable', dragEnabled);
            this._isDraggable = dragEnabled;
        },
        enumerable: true,
        configurable: true
    });
    NgxDraggableDirective.prototype.onDragStart = function (event) {
        if (this.el.nativeElement === event.target) {
            event.target.classList.add(this.draggedClass);
            event.dataTransfer.setData('data', JSON.stringify({ dd: this.dragData }));
            if (this.dragTag) {
                this.dragDropService.instanceName = this.dragTag;
            }
            else {
                this.dragDropService.setDefaultInstance();
            }
        }
    };
    NgxDraggableDirective.prototype.onDragEnd = function (event) {
        if (this.el.nativeElement === event.target) {
            event.target.classList.remove(this.draggedClass);
        }
    };
    return NgxDraggableDirective;
}());
__decorate$1([
    _angular_core.Input('ngx-draggable'),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], NgxDraggableDirective.prototype, "isDraggable", null);
__decorate$1([
    _angular_core.Input('ngx-dragTag'),
    __metadata("design:type", String)
], NgxDraggableDirective.prototype, "dragTag", void 0);
__decorate$1([
    _angular_core.Input('ngx-draggedClass'),
    __metadata("design:type", String)
], NgxDraggableDirective.prototype, "draggedClass", void 0);
__decorate$1([
    _angular_core.Input('ngx-dragData'),
    __metadata("design:type", Object)
], NgxDraggableDirective.prototype, "dragData", void 0);
__decorate$1([
    _angular_core.HostListener('dragstart', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], NgxDraggableDirective.prototype, "onDragStart", null);
__decorate$1([
    _angular_core.HostListener('dragend', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], NgxDraggableDirective.prototype, "onDragEnd", null);
NgxDraggableDirective = __decorate$1([
    _angular_core.Directive({
        selector: '[ngx-draggable]'
    }),
    __metadata("design:paramtypes", [_angular_core.ElementRef, NgxDragDropService])
], NgxDraggableDirective);

var __decorate$3 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") { r = Reflect.decorate(decorators, target, key, desc); }
    else { for (var i = decorators.length - 1; i >= 0; i--) { if (d = decorators[i]) { r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r; } } }
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$2 = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") { return Reflect.metadata(k, v); }
};
/* Copyright VMware, Inc. All rights reserved. VMware Confidential */
var NgxDroppableDirective = (function () {
    function NgxDroppableDirective(el, dragDropService) {
        this.el = el;
        this.dragDropService = dragDropService;
        this.onDropData = new _angular_core.EventEmitter();
        this.dropTags = [this.dragDropService.instanceName];
    }
    NgxDroppableDirective.prototype.onDragEnter = function (event) {
        if (event.preventDefault) {
            event.preventDefault();
        }
        if (event.stopPropagation) {
            event.stopPropagation();
        }
        if (this.el.nativeElement === event.target) {
            if (this.dropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                event.target.classList.add(this.dragDropService.instanceName);
            }
        }
    };
    NgxDroppableDirective.prototype.onDragOver = function (event) {
        if (event.preventDefault) {
            event.preventDefault();
        }
        if (event.stopPropagation) {
            event.stopPropagation();
        }
        if (this.el.nativeElement === event.target) {
            if (this.dropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                event.dataTransfer.effectAllowed = 'all';
                event.dataTransfer.dropEffect = 'move';
            }
            else {
                event.dataTransfer.effectAllowed = 'none';
                event.dataTransfer.dropEffect = 'none';
            }
        }
    };
    NgxDroppableDirective.prototype.onDragLeave = function (event) {
        if (event.preventDefault) {
            event.preventDefault();
        }
        if (event.stopPropagation) {
            event.stopPropagation();
        }
        if (this.el.nativeElement === event.target) {
            if (this.dropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                event.target.classList.remove(this.dragDropService.instanceName);
            }
        }
    };
    NgxDroppableDirective.prototype.onDrop = function (event) {
        if (event.preventDefault) {
            event.preventDefault();
        }
        if (event.stopPropagation) {
            event.stopPropagation();
        }
        if (this.el.nativeElement === event.target) {
            var dragTag = this.dragDropService.instanceName;
            var data = event.dataTransfer.getData('data');
            var dragData = JSON.parse(data).dd;
            if (this.dropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                event.target.classList.remove(this.dragDropService.instanceName);
                this.onDropData.emit({ dragTag: dragTag, dragData: dragData, dropData: this.dropData });
            }
        }
    };
    return NgxDroppableDirective;
}());
__decorate$3([
    _angular_core.Output('ngx-droppable'),
    __metadata$2("design:type", _angular_core.EventEmitter)
], NgxDroppableDirective.prototype, "onDropData", void 0);
__decorate$3([
    _angular_core.Input('ngx-dropTags'),
    __metadata$2("design:type", Array)
], NgxDroppableDirective.prototype, "dropTags", void 0);
__decorate$3([
    _angular_core.Input('ngx-dropData'),
    __metadata$2("design:type", Object)
], NgxDroppableDirective.prototype, "dropData", void 0);
__decorate$3([
    _angular_core.HostListener('dragenter', ['$event']),
    __metadata$2("design:type", Function),
    __metadata$2("design:paramtypes", [Object]),
    __metadata$2("design:returntype", void 0)
], NgxDroppableDirective.prototype, "onDragEnter", null);
__decorate$3([
    _angular_core.HostListener('dragover', ['$event']),
    __metadata$2("design:type", Function),
    __metadata$2("design:paramtypes", [Object]),
    __metadata$2("design:returntype", void 0)
], NgxDroppableDirective.prototype, "onDragOver", null);
__decorate$3([
    _angular_core.HostListener('dragleave', ['$event']),
    __metadata$2("design:type", Function),
    __metadata$2("design:paramtypes", [Object]),
    __metadata$2("design:returntype", void 0)
], NgxDroppableDirective.prototype, "onDragLeave", null);
__decorate$3([
    _angular_core.HostListener('drop', ['$event']),
    __metadata$2("design:type", Function),
    __metadata$2("design:paramtypes", [Object]),
    __metadata$2("design:returntype", void 0)
], NgxDroppableDirective.prototype, "onDrop", null);
NgxDroppableDirective = __decorate$3([
    _angular_core.Directive({
        selector: '[ngx-droppable]'
    }),
    __metadata$2("design:paramtypes", [_angular_core.ElementRef, NgxDragDropService])
], NgxDroppableDirective);

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") { r = Reflect.decorate(decorators, target, key, desc); }
    else { for (var i = decorators.length - 1; i >= 0; i--) { if (d = decorators[i]) { r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r; } } }
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
/* Copyright VMware, Inc. All rights reserved. VMware Confidential */
exports.NgxDragDropModule = NgxDragDropModule_1 = (function () {
    function NgxDragDropModule() {
    }
    NgxDragDropModule.forRoot = function () {
        return {
            ngModule: NgxDragDropModule_1,
            providers: []
        };
    };
    NgxDragDropModule.forChild = function () {
        return {
            ngModule: NgxDragDropModule_1,
            providers: []
        };
    };
    return NgxDragDropModule;
}());
exports.NgxDragDropModule = NgxDragDropModule_1 = __decorate([
    _angular_core.NgModule({
        declarations: [
            NgxDraggableDirective,
            NgxDroppableDirective
        ],
        providers: [NgxDragDropService],
        exports: [NgxDraggableDirective, NgxDroppableDirective]
    })
], exports.NgxDragDropModule);
var NgxDragDropModule_1;

/* Copyright VMware, Inc. All rights reserved. VMware Confidential */

Object.defineProperty(exports, '__esModule', { value: true });

})));
