var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/* Copyright VMware, Inc. All rights reserved. VMware Confidential */
import { Directive, ElementRef, Input, HostListener } from "@angular/core";
import { NgxDragDropService } from "./dragDrop.service";
var NgxDraggableDirective = (function () {
    function NgxDraggableDirective(el, dragDropService) {
        this.el = el;
        this.dragDropService = dragDropService;
        this._isDraggable = false;
    }
    Object.defineProperty(NgxDraggableDirective.prototype, "isDraggable", {
        get: function () {
            return this._isDraggable;
        },
        set: function (dragEnabled) {
            this.el.nativeElement.setAttribute('draggable', dragEnabled);
            this._isDraggable = dragEnabled;
        },
        enumerable: true,
        configurable: true
    });
    NgxDraggableDirective.prototype.onDragStart = function (event) {
        if (this.el.nativeElement === event.target) {
            event.target.classList.add(this.draggedClass);
            event.dataTransfer.setData('data', JSON.stringify({ dd: this.dragData }));
            if (this.dragTag) {
                this.dragDropService.instanceName = this.dragTag;
            }
            else {
                this.dragDropService.setDefaultInstance();
            }
        }
    };
    NgxDraggableDirective.prototype.onDragEnd = function (event) {
        if (this.el.nativeElement === event.target) {
            event.target.classList.remove(this.draggedClass);
        }
    };
    return NgxDraggableDirective;
}());
__decorate([
    Input('ngx-draggable'),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], NgxDraggableDirective.prototype, "isDraggable", null);
__decorate([
    Input('ngx-dragTag'),
    __metadata("design:type", String)
], NgxDraggableDirective.prototype, "dragTag", void 0);
__decorate([
    Input('ngx-draggedClass'),
    __metadata("design:type", String)
], NgxDraggableDirective.prototype, "draggedClass", void 0);
__decorate([
    Input('ngx-dragData'),
    __metadata("design:type", Object)
], NgxDraggableDirective.prototype, "dragData", void 0);
__decorate([
    HostListener('dragstart', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], NgxDraggableDirective.prototype, "onDragStart", null);
__decorate([
    HostListener('dragend', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], NgxDraggableDirective.prototype, "onDragEnd", null);
NgxDraggableDirective = __decorate([
    Directive({
        selector: '[ngx-draggable]'
    }),
    __metadata("design:paramtypes", [ElementRef, NgxDragDropService])
], NgxDraggableDirective);
export { NgxDraggableDirective };
//# sourceMappingURL=draggable.directive.js.map